var $ = jQuery;
$(function() { 
	// Проверка на число, причем NaN не помеха
	function isNum(v) {
			return typeof v === 'number' && isFinite(v);
	} 

	// Шаблон мероприятия
	function GetSubModuleTmp(){
		return '\
		<div class="subModule">\
			<div class="name">\
				<input type="text" class="inputName" value="Наименование мероприятия">\
			</div>\
			<div class="currentControl"><input type="text" class="inputCredit inputCurrentControl" value=""></div>\
			<div class="landmarkControl"><input type="text" class="inputCredit inputLandmarkControl" value=""></div>\
			<div class="actions">\
				<div class="deleteSubModule delete"></div>\
				<div class="downSubModule down"></div>\
				<div class="upSubModule up"></div>\
			</div>\
		</div>\
		';
	}
	
	// Шаблон модуля
	function GetModuleTmp() {
		return '\
		<div class="moduleGroup">\
			<div class="moduleHead">\
				<div class="name">\
					<input type="text" class="inputName" value="Модуль №. Наименование модуля">\
				</div>\
				<div class="currentControl">0</div>\
				<div class="landmarkControl">0</div>\
				<div class="actions">\
					<div class="deleteModule delete"></div>\
					<div class="downModule down"></div>\
					<div class="upModule up"></div>\
					<div class="addSubModule add"></div>\
				</div>\
			</div>\
			<div class="subModules">\
			'+GetSubModuleTmp()+'\
			</div>\
		</div>'
	};
	
	// Подсчет текущего контроля
	function CountCurrentControl(subModulesDiv){
		var maxCredits = 0;
		$('.inputCurrentControl', subModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0); 
		});
		subModulesDiv.prev().children('.currentControl').text(maxCredits);
	}
	// Подсчет рубежного контроля
	function CountLandmarkControl(subModulesDiv){
		var maxCredits = 0;
		$('.inputLandmarkControl', subModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0); 
		});
		subModulesDiv.prev().children('.landmarkControl').text(maxCredits);
	}
	
	// Переместить вверх МОДУЛЬ
    $(".moduleList").on('click', '.upModule', function(){
        var parentdiv = $(this).parent('div').parent('div').parent('div');
        parentdiv.insertBefore(parentdiv.prev());
        return false
    });
	
	// Переместить вниз МОДУЛЬ
    $(".moduleList").on('click', '.downModule', function(){
        var parentdiv = $(this).parent('div').parent('div').parent('div');
        parentdiv.insertAfter(parentdiv.next());
        return false
    });
	
	// Переместить вверх мероприятие
    $(".moduleList").on('click', '.upSubModule', function(){
        var parentdiv = $(this).parent('div').parent('div');
        parentdiv.insertBefore(parentdiv.prev());
        return false
    });
	
	// Переместить вниз мероприятие
    $(".moduleList").on('click', '.downSubModule', function(){
        var parentdiv = $(this).parent('div').parent('div');
        parentdiv.insertAfter(parentdiv.next());
        return false
    });
	
	// Добавить новый элемент в конец
	$('.addModule').click(function(){
		$('.moduleList').append(GetModuleTmp());
	});
	
	// Добавить мероприятие
	$('.moduleList').on('click', '.addSubModule', function(){
		$(this).parent().parent().next().append(GetSubModuleTmp());
	});
	
	// Удалить модуль
	$('.moduleList').on('click', '.deleteModule', function(){
		$(this).parent('div').parent('div').parent('div').remove();
	});
	
	// Удалить мероприятие
	$('.moduleList').on('click', '.deleteSubModule', function(){
		var subModulesDiv = $(this).parent().parent().parent();
		$(this).parent('div').parent('div').remove();
		CountCurrentControl(subModulesDiv);
		CountLandmarkControl(subModulesDiv);
	});
	
	// При записи в input текущий контроль
	// При фокусе
	$('.moduleList').on('focusin', '.inputCurrentControl', function(){
		//alert('Фокус');
	});
	// При потери фокуса
	$('.moduleList').on('focusout', '.inputCurrentControl', function(){
		var subModulesDiv = $(this).parent().parent().parent();
		CountCurrentControl(subModulesDiv);
	});
	
	// При записи в input рубежный контроль
	// При фокусе
	$('.moduleList').on('focusin', '.inputLandmarkControl', function(){
		//alert('Фокус');
	});
	// При потери фокуса
	$('.moduleList').on('focusout', '.inputLandmarkControl', function(){
		var subModulesDiv = $(this).parent().parent().parent();
		CountLandmarkControl(subModulesDiv);
	});
	
	// В inputCredit (где баллы вводить) разрешаем вводить только цифры
	$(".moduleList").on('keydown', '.inputCredit', function(event) {
        // Разрешаем: backspace, delete, tab и escape
        if ( event.keyCode == 46 || event.keyCode == 8 || event.keyCode == 9 || event.keyCode == 27 || 
             // Разрешаем: Ctrl+A
            (event.keyCode == 65 && event.ctrlKey === true) || 
             // Разрешаем: home, end, влево, вправо
            (event.keyCode >= 35 && event.keyCode <= 39)) {
                 // Ничего не делаем
                 return;
        }
        else {
            // Убеждаемся, что это цифра, и останавливаем событие keypress
            if ((event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105 )) {
                event.preventDefault(); 
            }   
        }
    });
	
	// При нажатие кнопки 'сохранить' генерация JSON
	$('.saveStudyMap').click(function(){
		// jsonModules - JSON данные, для отправки на сервер
		var jsonModules = '{';
		var amountModulesHead = $('.moduleGroup').size();
		$('.moduleGroup').each(function(i){
			jsonModules += i+':{';
			var jsonModule = '"moduleHead": {"moduleName":"'+$(this).children('.moduleHead').children('.name').children('.inputName').val()+'", "id":"id/hash here", "currentControl":"'+$(this).children('.moduleHead').children('.currentControl').text()+'", "landmarkControl":"'+$(this).children('.moduleHead').children('.landmarkControl').text()+'"},';
			// jsonSubModules - мероприятия в JSON представление
			var jsonSubModules = '"subModules":{';
			var amountSubModules = $('.subModule', this).size();
			$('.subModule', this).each(function(i){
				var subModuleName = $(this).children('.name').children('.inputName').val();
				jsonSubModules += ''+i+':{"subModuleName":"'+subModuleName+'","id":"id/hash here"}';
				jsonSubModules += (i + 1 == amountSubModules) ? '' : ',';
			});
			jsonSubModules += '}';
			jsonModules += jsonModule+jsonSubModules;
			jsonModules += (i + 1 == amountModulesHead) ? '}' : '},';
			//console.log(JSON.stringify('{'+jsonModule+jsonSubModules+'}'));
		});
		jsonModules += '}';
		console.log(JSON.stringify(jsonModules));
	});

	
	// При нажатие кнопки сохранить
	/*
	$('.saveStudyMap').click(function(){
		var modulesArray = new Array(); // Массив с учебной картой дисциплины, который затем перегоняем в JSON
		$('.moduleGroup').each(function(){
			var moduleGroup = new Array(); // Массив с названием модуля и массивом с названиями мероприятиый
			moduleGroup.push($(this).children('.module').children('.moduleName').children('.title').text());
			var subModuleArray = new Array(); // Массив с названиями мероприятий модуля, который затем вставляем в массив moduleGroup
			$('.subModule', this).each(function(){
				var subModuleName = $(this).children('.subModuleName').children('.title').text();
				subModuleArray.push(subModuleName); // Добавялем в массив название мероприятия модуля
			});
			moduleGroup.push(subModuleArray); // Добавялем массив с названиями мероприятий модуля в moduleGroup
			modulesArray.push(moduleGroup); // Добавляем в массив модуль (полный, т.е. название и массив с названиями мероприятий)
		});
		var jsonData = JSON.stringify(modulesArray);
		console.log(modulesArray); console.log(jsonData);
	});
	*/
});
